#ifndef COMMUNICATION_H_
#define COMMUNICATION_H_

//**************************** Communication ******************

int8_t Init_Driver(uint8_t *Display_Name)
{
	if (!strcmp(Display_Name, pattern))
    {
		/*
		// for cut3
		cmd = 0x00;
		addr = 0x05;
		Input[0] = 0x48;	
		length = 1;
		Length = &length;
		DataIn = &Input[0];
		DataOut = &Output[0];
		//Clear_Screen();   
		//Display_Message("V-blanking setting");
		SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
		*/		
			
#if(LOT2)

#if(PANEL)	
    cmd = 0x00;
	addr = 0x00;	
	length = 22*7;
	Length = &length;
	DataIn = &_PANEL_value[0];	
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("Set gamma table");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
#elif(GM_4_2)
	
    cmd = 0x00;
	addr = 0x00;	
	length = 22*7;
	Length = &length;
	DataIn = &_4_2_value[0];	
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("Set gamma table");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);	

#elif(GM_8)
	cmd = 0x00;
	addr = 0x00;	
	length = 22*7;
	Length = &length;
	DataIn = &_8_value[0];	
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("Set gamma table");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
#endif
	/*
	// for cut3
	cmd = 0x00;
	addr = 0x05;
	Input[0] = 0x48;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	//Clear_Screen();   
	//Display_Message("V-blanking setting");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	*/			
	cmd = 0x00;
	addr = 0x06;
	Input[0] = 0xC5;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("flicker pattern");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
		
	cmd = 0x00;
	addr = 0x00;
	Input[0] = 0x07;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("Select page 7");
	
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);	
#endif
    } 
    else
    {
        Display_Message("Wrong Driver Name in Init_Driver");
        return -1;
    }
   	
    return 0;
}

int8_t Reset_Driver(uint8_t *Display_Name){return 0;}

int8_t Init_Protocol(uint8_t *Driver_Name)
{	
	Initialise_Names();
	
	if (!strcmp(Driver_Name,pattern))
	{		
		Write_Data(1);									// IOData is Output
		//Write_Cont(1);									// IOControl is Output
		//EnableInputControl(0);							// Enable all control line.
		EnableInputData(0);								// Enable all Data line.
		
		OutputDigitalData(0);							// Set idle Data line to logic high.
		//OutputDigitalControl(0);						// Set idle control line to logic high.

		if(_24BITS)
			SelectDigitalSoftwareControl(TB+RL+DINT+BIST+EEPEN+RESET+PW_EN+SPI_CS+SPI_CLK+SPI_MOSI+SPI_MISO, 0);
		else
			SelectDigitalSoftwareControl(TB+RL+BIST+RESET+EEPEN+PW_EN+SPI_CS+SPI_CLK+SPI_MOSI+SPI_MISO, 0);
						
		WriteFpgaReg(cProtocol, cProtocol_Rgb_Dword);
		WriteFpgaReg(cRgbCtrlReg,RGB_CLOCK + RGB_ENABLE);
#if(GM_4_2)			
			SetFrequency(9190);
			WriteFpgaReg(iRgbPixelsX, 480);				// Number of display pixels horizontal
			WriteFpgaReg(iRgbPixelsY, 272);					// Number of display pixels vertical
			WriteFpgaReg(iRgbClocksLine, 512);				// Total number of clock pulses per line
			WriteFpgaReg(iRgbLinesFrame, 299);				// Total number of lines within frame		
#elif(GM_8)				
			SetFrequency(26360);
			WriteFpgaReg(iRgbPixelsX, 800);				// Number of display pixels horizontal
			WriteFpgaReg(iRgbPixelsY, 480);					// Number of display pixels vertical
			WriteFpgaReg(iRgbClocksLine, 832);				// Total number of clock pulses per line
			WriteFpgaReg(iRgbLinesFrame, 528);				// Total number of lines within frame
#elif(BMW_10_25)
			SetFrequency(41560);
			WriteFpgaReg(iRgbPixelsX, 1280);				// Number of display pixels horizontal
			WriteFpgaReg(iRgbPixelsY, 480);					// Number of display pixels vertical
			WriteFpgaReg(iRgbClocksLine, 1312);				// Total number of clock pulses per line
			WriteFpgaReg(iRgbLinesFrame, 528);				// Total number of lines within frame
		
#endif
		WriteFpgaReg(cRgbHorPos, 8);	  				// Horizontal position (Horizontal Back Proch)
		WriteFpgaReg(cRgbVerPos, 4);					// Vertical position (Vertical Back Proch)
		WriteFpgaReg(cRgbHorSync, 8);	 				// Duration of Horizontal sync in clock pulses (Horizontal Pulse Width)
		WriteFpgaReg(cRgbVerSync, 4);					// Duration of Vertical sync in clock pulses (Vertical Pulse Width)
	  		
		//WriteFpgaReg(cColorExpansion , cDWORD);		
	
		if(_24BITS)
		SelectDigitalSoftwareControl(TB+RL+DINT+BIST+RESET+EEPEN+PW_EN+SPI_CS+SPI_CLK+SPI_MOSI+SPI_MISO, 0);
		else
		SelectDigitalSoftwareControl(TB+RL+BIST+RESET+EEPEN+PW_EN+SPI_CS+SPI_CLK+SPI_MOSI+SPI_MISO, 0);

	}		
	else
	{
		Display_Message("Wrong Driver Name in Init_protocol\n");
		return -1;
	}
	return 0;
}

void Send_Command(uint32_t value){;}

void Send_Data(uint32_t value){;}

//*************************************************************

#endif /*COMMUNICATION_H_*/
