//======== Test stage select =======================
	#define delay			2000
	#define AUTO_FLICKER	TRUE
	#define GM_4_2			FALSE
	#define GM_8			TRUE
	#define BMW_10_25		FALSE
	#define _24BITS			TRUE
	#define _18BITS			FALSE
	#define EEPROM			FALSE
	#define NTC				FALSE
	#define DISPLAY			FALSE
	#define LOT2			TRUE
	#define LOT3			FALSE
	#define OQC				FALSE
	#define DQA				FALSE
	#define TESTMODE	 	TRUE
	#define	BPP1			FALSE
	#define	BPP2			FALSE
	#define	BPP4			FALSE
//======== Test stage select =======================

#include "project_setting.h"
#include "tool.h"
void TestProgram(void)
{	
	Init_Power();	
	Init_Protocol(pattern);
	Display_Bitmap(	pattern , default_pattern);	// default pattern
	
	Clear_Screen();		

	while(1)
	{		

	if(_24BITS)
	Display_Message("Operation in 24bits mode.\n");	
	else
	Display_Message("Operation in 18bits mode.\n");
	if(GM_4_2)
	Display_Message("Resolution is 480 x 272.\n");
	else if(GM_8)
	Display_Message("Resolution is 800 x 480.\n");
	else if(BMW_10_25)
	Display_Message("Resolution is 1280 x 480.\n");
	
	RedLed(0);
	YellowLed(2);
	Wait_Halt(1);
	YellowLed(0);
	GreenLed(2);
	if(GM_4_2)
	Display_Message("GM 4.2' LOT2 test program.\n");
	else if(GM_8)
	Display_Message("GM 8' LOT2 test program.\n");
	else if(BMW_10_25)
	Display_Message("BMW10.25' LOT2 test program.\n");
	
	Wait_Halt(100);
	if(Option_Pressed())break;	
	GreenLed(0);
	
	Clear_Screen();
	Display_Message("Step1:\n");	
	Display_Message("Open Data logging and then enter Worker's Batch ID.\n");
	Display_Message("Make curser Sample ID\n"); 	
	
	YellowLed(2);
	Wait_Halt(1);
	YellowLed(0);
	GreenLed(2);	
	if(Option_Pressed())break;	

	Clear_Screen();
	Display_Message("Step2:\n");	
	Display_Message("The OTP step.\n");	
	
	GreenLed(0);
	YellowLed(2);
	Display_Bitmap( pattern, flicker_dot_186);
	otp();
	RedLed(0);
	
	Display_Message("please release the flicker sensor.\n press start button to continue.\n");
	
	while(1)
	{	
		Wait_Halt(300);
		if(Start_Pressed()&&!Halt_Pressed())
			break;
	}	
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(1000);
	if(Option_Pressed())break;
	
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step3:\n");		
	Display_Message("Show the Test pattern 'White'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , white);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(white,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(white,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(white,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(white,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);		
		test_function(white,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;	

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step4:\n");		
	Display_Message("Show the Test pattern 'Black'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , black);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(black,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(black,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(black,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(black,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(black,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;	

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step5:\n");		
	Display_Message("Show the Test pattern 'Red'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , red);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(red,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(red,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(red,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(red,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(red,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step6:\n");		
	Display_Message("Show the Test pattern 'Green'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , green);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(green,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(green,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(green,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(green,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(green,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step7:\n");		
	Display_Message("Show the Test pattern 'Blue'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , blue);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(blue,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(blue,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(blue,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(blue,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(blue,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step8:\n");		
	Display_Message("Show the Test pattern 'Color bar'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , color_bar_v);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(color_bar_v,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(color_bar_v,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(color_bar_v,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(color_bar_v,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(color_bar_v,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;
	
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step9:\n");		
	Display_Message("Show the Test pattern 'Grayscale'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , grayscale_v);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(grayscale_v,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(grayscale_v,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(grayscale_v,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(grayscale_v,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(grayscale_v,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;	

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step10:\n");		
	Display_Message("Show the Test pattern 'Gray'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , gray);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(gray,"(VDDP_SEN)",VDDP_SEN,I_VDDP_MIN, I_VDDP_MAX);
		test_function(gray,"(VDDN_SEN)",VDDN_SEN,I_VDDN_MIN, I_VDDN_MAX);
		test_function(gray,"(VGH_SEN)",VGH_SEN,I_VGH_MIN, I_VGH_MAX);
		test_function(gray,"(VGL_SEN)",VGL_SEN,I_VGL_MIN, I_VGL_MAX);	
		test_function(gray,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;			
	
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step22:\n");
	Display_Message("The AMT testing is finish.\n");  
	Display_Float("Waitting for %5.2f sec.\n",((float)1000/1000.0));	
	Wait_Halt(delay);
	if(Option_Pressed())break;	

	Clear_Screen();
	Display_Message("Step23:\n");	
	Display_Message("Disconnect the main foil.\n");		
	Display_Float("Waitting for %5.2f sec.\n",((float)1000/1000.0));
	Wait_Halt(delay);
	if(Option_Pressed())break;
	GreenLed(0);
		
	break; 
	
	}// while(Engineer_Pressed)
		
	Display_Bitmap(	pattern , black);
	Wait_Halt(100);
	ResetDigitalControl(BIST);
}
