//======== Test stage select =======================
	#define delay			1500
	#define AUTO_FLICKER	TRUE
	#define GM_4_2			TRUE
	#define GM_8			FALSE
	#define BMW_10_25		FALSE
	#define _24BITS			TRUE
	#define _18BITS			FALSE
	#define EEPROM			FALSE
	#define NTC				FALSE
	#define DISPLAY			FALSE
	#define LOT2			FALSE
	#define LOT3			TRUE
	#define OQC				FALSE
	#define DQA				FALSE
	#define TESTMODE	 	TRUE
	#define	BPP1			FALSE
	#define	BPP2			FALSE
	#define	BPP4			FALSE
	#define GAMMA_CHECK		TRUE
//======== Test stage select =======================

#include "project_setting.h"
#include "tool.h"
void TestProgram(void)
{	
	unsigned int i;
	Init_Power();		
	Init_Protocol(pattern);
	Display_Bitmap(	pattern , default_pattern);	// default pattern
	
	Clear_Screen();		

	while(1)
	{

	if(_24BITS)
	Display_Message("Operation in 24bits mode.\n");	
	else
	Display_Message("Operation in 18bits mode.\n");
	if(GM_4_2)
	Display_Message("Resolution is 480 x 272.\n");
	else if(GM_8)
	Display_Message("Resolution is 800 x 480.\n");
	else if(BMW_10_25)
	Display_Message("Resolution is 1280 x 480.\n");
			
	RedLed(0);
	YellowLed(2);
	Wait_Halt(1);
	YellowLed(0);
	GreenLed(2);
	if(GM_4_2)
	Display_Message("GM 4.2' LOT3 test program.\n");
	else if(GM_8)
	Display_Message("GM 8' LOT3 test program.\n");
	else if(BMW_10_25)
	Display_Message("BMW10.25' LOT3 test program.\n");

	Wait_Halt(100);
	if(Option_Pressed())break;
#if(GAMMA_CHECK)	
	Clear_Screen();
	Display_Message("Gamma version check...\n");
	
	cmd = 0x00;
	addr = 0x00;
	Input[0] = 0x00;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];	   
	Display_Message("Select page 0.\n");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	cmd = 0x04;
	addr = 0x00;	
	length = 22*7;	
	Length = &length;
	DataIn = &Input[0];		
	DataOut = &Output[0];	  
	Display_Message("Read all data.\n");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);	
		
	for(i=2;i<132;i++)
	{
		/*
		Clear_Screen();
		Display_Integer("i %d",i);
		Display_Integer("Output %d",Output[i]);
		Display_Integer("_4_2_value %d",_4_2_value[i]);
		Wait_Halt(100);
		*/
#if(GM_4_2)
		if(Output[i] != _4_2_value[i])
#elif(GM_8)
		if(Output[i] != _8_value[i])
#endif
		{
			
			Display_Message("Gamma version error.\n");
			Wait_Halt(100);
			RedLed(1);
			break;
		}		
	}
#endif	
	RedLed(0);
	Wait_Halt(100);	
	if(Option_Pressed())break;
	GreenLed(0);
	
	Clear_Screen();
	Display_Message("Step12:\n");	
	Display_Message("Open Data logging and then enter Worker's Batch ID.\n");
	Display_Message("Make curser Sample ID\n"); 	
	
	YellowLed(2);		
	Wait_Halt(1);
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(1000);	
	if(Option_Pressed())break;
	
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step13:\n");		
	Display_Message("Show the Test pattern 'White'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , white);
	YellowLed(2);
	if(TESTMODE)
	{
		test_function(white,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
		test_function(white,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;	

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step14:\n");
	Display_Message("Show the Test pattern 'Black'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , black);
	YellowLed(2);
	if(TESTMODE)
	{
	test_function(black,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(black,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step15:\n");
	Display_Message("Show the Test pattern 'Red'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , red);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(red,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(red,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;	
	
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step16:\n");
	Display_Message("Show the Test pattern 'Green'.\n"); 
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , green);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(green,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(green,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step17:\n");
	Display_Message("Show the Test pattern 'Blue'.\n");	
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , blue);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(blue,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(blue,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;
	
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step18:\n");
	Display_Message("Show the Test pattern 'Color bar'.\n");
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , color_bar_v);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(color_bar_v,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(color_bar_v,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;
	 
	GreenLed(0);
	Clear_Screen();
	Display_Message("Step19:\n");
	Display_Message("Show the Test pattern 'Grayscale'.\n");
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , grayscale_v);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(grayscale_v,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(grayscale_v,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step20:\n");
	Display_Message("Show the Test pattern 'Gray'.\n");  
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , gray);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(gray,"(VBL_SEN)",VBL_SEN, I_VBL_MIN, I_VBL_MAX);	
	test_function(gray,"(VCC_SEN)",VCC_SEN, I_VCC_MIN, I_VCC_MAX);
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step21:\n");
	Display_Message("Show the Test pattern 'Flicker'.\n");  
	Display_Float("Waitting for %5.2f sec.\n",((float)delay/1000.0));
	Display_Bitmap(	pattern , flicker_dot_186);
	YellowLed(2);	
	if(TESTMODE)
	{
	test_function(flicker_dot_186,"(VBL_SEN)",VBL_SEN,I_VBL_MIN, I_VBL_MAX);	
	test_function(flicker_dot_186,"(VCC_SEN)",VCC_SEN,I_VCC_MIN, I_VCC_MAX);
	

// data logging VCOM -------------------------------------------------
	cmd = 0x00;
	addr = 0x00;
	Input[0] = 0x07;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("change to page 7");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);

	cmd = 0x04;
	addr = 0x01;
	Input[0] = 0x00;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	//Clear_Screen();   
    //Display_Message("read VCOM");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	test_function(flicker_dot_186,"(VCOM)",(uint8_t)Output[0],0,255);
//--------------------------------------------------------------------
	}
	YellowLed(0);
	GreenLed(2);
	Wait_Halt(delay);	
	if(Option_Pressed())break;	

	GreenLed(0);
	Clear_Screen();
	Display_Message("Step22:\n");
	Display_Message("The AMT testing is finish.\n");  
	Display_Float("Waitting for %5.2f sec.\n",((float)1000/1000.0));	
	Wait_Halt(delay);
	if(Option_Pressed())break;	

	Clear_Screen();
	Display_Message("Step23:\n");	
	Display_Message("Disconnect the main foil.\n");		
	Display_Float("Waitting for %5.2f sec.\n",((float)1000/1000.0));
	Wait_Halt(delay);
	if(Option_Pressed())break;
	GreenLed(0);
		
	break; 
	
	}// while(Engineer_Pressed)
		
	Display_Bitmap(	pattern , black);
	Wait_Halt(100);
	ResetDigitalControl(BIST);

}
