#ifndef POWER_H_
#define POWER_H_

void Init_Power(void)
{
	ResetDigitalControl(RESET);
	Out_Dac(VBL,0);
	Out_Dac(POWER,0);	
	Wait(500);

	Out_Dac(V_Low,0);
	Out_Dac(V_High,3.3);
	Write_Cont(1);									// IOControl is Output
	EnableInputControl(0);							// Enable all control line.			
	OutputDigitalControl(0);						// Reset all control line.

	SelectDigitalSoftwareControl(ALLIOCTRL, 0);

	Out_Dac(POWER,VCC);	
	Out_Dac(VBL,Vbl);
	//Display_Message("Vgh");
	//Wait_Halt(100);
	Out_Dac(VGH,Vgh);	

	Wait(1000);		

	SetDigitalControl(RESET);	
	Wait(1000);
#if(LOT2)
	Init_Driver(pattern);
#endif
	Out_Dac(VDDP,Vddp);	
	Out_Dac(VDDN,Vddn);
	//Wait(100);	
	
	Enable_Vlcd(1);	
 
	Out_Dac(VGL,Vgl);		// hardware define	
	
	//Wait_Halt(100);	

	//Display_Message("VBL");
	//Wait_Halt(100);	
	SetDigitalControl(PW_EN);

	Out_Dac(VDD_OTP,VDD_otp);	
	Enable_Votp(1);

	//Display_Message("PWM");
	//Wait_Halt(100);
	
	Pwm1(200,100);	
	Out_Dac(VOP,Vop);

	//Display_Message("EEPROM Enable");
	//Wait_Halt(100);
	ResetDigitalControl(EEPEN);		

	//Display_Message("TB");
	//Wait_Halt(100);
	SetDigitalControl(TB);

	//Display_Message("RL");
	//Wait_Halt(100);
	SetDigitalControl(RL);

	//Display_Message("DINT");
	//Wait_Halt(100);
	
	if(_24BITS)
	SetDigitalControl(DINT);		// 8bit
	else
	ResetDigitalControl(DINT);	
	
	#if(LOT2)	
	Display_Message("Run BIST mode");
	SetDigitalControl(BIST);
	Init_Driver(pattern);
	Wait_Halt(100);
	ResetDigitalControl(BIST);	
#endif
}
void Reset_Power(void){;}

void Backlight(int8_t on){;}

uint8_t Open_Short_Test(void){return 0;}

void Init_Module(void){;}

void Reset_Module(void){;}

#endif /*POWER_H_*/
