#ifndef PROJECT_SETTING_H_
#define PROJECT_SETTING_H_

#include "SD5238.h"

/**************************************************************************************
 *						 
 *  	FILENAME:		Project_setting.h	
 *
 *  	Project:    	DJ042PA-01A
 *						DJ080PA-01A
 *						DJ080PA-01B
 *						DJ103FA-01A
 *
 *    	DESCRIPTION:	Set parmeter in project
 *
 *    	Modified by:	Tonyder.Lin/CMI		
 *    	HISTORY:    		
 *		First Issue		2011/01/05 - LOT3 first Version
 *						2011/01/23 - Change the sequence between black and white pattern
 *						2011/03/07 - Transfer to GMT
 *						2011/03/10 - Add auto flicker function
 *								   - 4.2 inch LOT2 in GMT
 *								   - 8 inch LOT2 in GMT
 *								   - 10.25 inch LOT2 in GMT
 *						2011/05/06 - modify initial power
 *						2011/06/27 - GMT adapt second version, modify function PW_EN
 *						2011/07/07 - Add VCC current, VBL current and VCOM to Data logging.
 * 						2011/08/16 - Starting to use Eclipse
 * 								   - divide into Communication.h Display.h Misc.h Power.h
 * 						2011/1018  - update the gamma table to DV2-1 M2
 *		
***************************************************************************************/

	#if(GM_4_2)
	uint8_t Project[]	="DJ042PA-01A";	
	uint8_t Author[]	="Tonyder.Lin";
#elif(GM_8)
	uint8_t Project[]	="DJ08PA-01A";	
	uint8_t Author[]	="Tonyder.Lin";
#elif(BMW_10_25)
	uint8_t Project[]	="DJ103FA-01A";	
	uint8_t Author[]	="Tonyder.Lin";
#endif
	//=== program version infomation ======//
#if(GM_4_2)
	#if LOT2
	uint8_t Program_9nc[]	= "520003907E";
	uint8_t Program[]		= "LOT2 test program";
	uint8_t Update_date[]	= "20111018";
	#endif

	#if LOT3
	uint8_t Program_9nc[]	= "520003908E";
	uint8_t Program[]		= "LOT3 test program";
	uint8_t Update_date[]	= "20111018";
	#endif
#elif(GM_8)
	#if LOT2
	uint8_t Program_9nc[]	= "520003909E";
	uint8_t Program[]		= "LOT2 test program";
	uint8_t Update_date[]	= "20111003";
	#endif

	#if LOT3
	uint8_t Program_9nc[]	= "520003910E";
	uint8_t Program[]		= "LOT3 test program";
	uint8_t Update_date[]	= "20111003";
	#endif
#elif(BMW_10_25)
	#if LOT2
	uint8_t Program_9nc[]	= "520003913D";
	uint8_t Program[]		= "LOT2 test program";
	uint8_t Update_date[]	= "20110815";
	#endif
#endif
	
#if(DISPLAY)	
	uint8_t Program_9nc[]	= "Null";
	uint8_t Program[]		= "Elop";
	uint8_t Update_date[]	= "20110707";
#endif
	
#if NTC
uint8_t Program_9nc[]	= "ME";
uint8_t Program[]		= "NTC";
uint8_t Update_date[]	= "20110428";
#endif

#if DQA
uint8_t Program_9nc[]	= "Testting house";
uint8_t Program[]		= "Testting house";
uint8_t Update_date[]	= "20110721";
#endif

#if OQC
uint8_t Program_9nc[]	= "Testting house";
uint8_t Program[]		= "Color correlation";
uint8_t Update_date[]	= "20110707";
#endif

#if(ISSUE_H_line)
uint8_t Program_9nc[]	= "Panel design";
uint8_t Program[]		= "H line";
uint8_t Update_date[]	= "20110812";
#endif

#if(ISSUE_carbon)
uint8_t Program_9nc[]	= "Elop";
uint8_t Program[]		= "carbon";
uint8_t Update_date[]	= "20110721";
#endif


#if(SANYO_Issue)
unsigned int _DV1_value[] =
	{
		//	4.2 inch
			
	0x00,0x00,0x00,0xE1,0xF0,0x40,0xCF,0x05,0x10,0xFC,0xF0,0x20,0x20,0x20,0x10,0x10,0x10,0x50,0x20,0x50,0x20,0x00,0x00, 
		0x00,0xEB,0x28,0x40,0x4D,0x70,0x8B,0xA1,0xCD,0xFD,0x36,0x7F,0xEE,0x42,0x83,0xB6,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xF4,0x2E,0x44,0x4F,0x6E,0x86,0x99,0xBD,0xE6,0x16,0x55,0xBA,0x0D,0x56,0x95,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xEB,0x28,0x40,0x4D,0x70,0x8B,0xA1,0xCD,0xFD,0x36,0x7F,0xEE,0x42,0x83,0xB6,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xF4,0x2E,0x44,0x4F,0x6E,0x86,0x99,0xBD,0xE6,0x16,0x55,0xBA,0x0D,0x56,0x95,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xEB,0x28,0x40,0x4D,0x70,0x8B,0xA1,0xCD,0xFD,0x36,0x7F,0xEE,0x42,0x83,0xB6,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xF4,0x2E,0x44,0x4F,0x6E,0x86,0x99,0xBD,0xE6,0x16,0x55,0xBA,0x0D,0x56,0x95,0xFC,0x50,0x55,0xA5,0xFE,0x03			
	};
#elif(PANEL)
unsigned int _PANEL_value[] =
	{
		//	4.2 inch
			
	0x00,0x00,0x00,0xE1,0xF0,0x48,0xCA,0x05,0x10,0xFC,0xF0,0x20,0x20,0x20,0x10,0x10,0x10,0x50,0x20,0x50,0x20,0x00,0x00, 
		0x00,0x94,0x2A,0x4F,0x53,0x68,0x8E,0xB4,0xDA,0x11,0x49,0x94,0x04,0x60,0xA7,0xD6,0xFC,0x50,0x55,0xA9,0xFF,0x03,		
		0x00,0x94,0x2A,0x4F,0x53,0x68,0x8E,0xB4,0xDA,0x11,0x49,0x94,0x04,0x60,0xA7,0xD6,0xFC,0x50,0x55,0xA9,0xFF,0x03,
		0x00,0x94,0x2A,0x4F,0x53,0x68,0x8E,0xB4,0xDA,0x11,0x49,0x94,0x04,0x60,0xA7,0xD6,0xFC,0x50,0x55,0xA9,0xFF,0x03,		
		0x00,0x94,0x2A,0x4F,0x53,0x68,0x8E,0xB4,0xDA,0x11,0x49,0x94,0x04,0x60,0xA7,0xD6,0xFC,0x50,0x55,0xA9,0xFF,0x03,		
		0x00,0x94,0x2A,0x4F,0x53,0x68,0x8E,0xB4,0xDA,0x11,0x49,0x94,0x04,0x60,0xA7,0xD6,0xFC,0x50,0x55,0xA9,0xFF,0x03,		
		0x00,0x94,0x2A,0x4F,0x53,0x68,0x8E,0xB4,0xDA,0x11,0x49,0x94,0x04,0x60,0xA7,0xD6,0xFC,0x50,0x55,0xA9,0xFF,0x03			
	};
#elif(GM_4_2)	
unsigned int _4_2_value[] =
	{
		//	4.2 inch			
	0x00,0x00,0x00,0xE1,0xF0,0x40,0xCF,0x05,0x10,0xFA,0xF0,0x20,0x20,0x20,0x10,0x10,0x10,0x50,0x20,0x50,0x20,0x00,0x00,
	
		0x00,0xC5,0x32,0x53,0x66,0x9D,0xBC,0xD2,0x00,0x2F,0x66,0xAB,0x0F,0x61,0xA2,0xCE,0xFC,0x50,0x55,0xAA,0xFF,0x03,
		0x00,0x8C,0xD7,0xF0,0xFE,0x2A,0x43,0x56,0x7E,0xAA,0xDF,0x26,0x9A,0x05,0x62,0xAA,0xFC,0x00,0x54,0x95,0xFE,0x03,
		0x00,0xC5,0x32,0x53,0x66,0x9D,0xBC,0xD2,0x00,0x2F,0x66,0xAB,0x0F,0x61,0xA2,0xCE,0xFC,0x50,0x55,0xAA,0xFF,0x03,
		0x00,0x8C,0xD7,0xF0,0xFE,0x2A,0x43,0x56,0x7E,0xAA,0xDF,0x26,0x9A,0x05,0x62,0xAA,0xFC,0x00,0x54,0x95,0xFE,0x03,
		0x00,0xC5,0x32,0x53,0x66,0x9D,0xBC,0xD2,0x00,0x2F,0x66,0xAB,0x0F,0x61,0xA2,0xCE,0xFC,0x50,0x55,0xAA,0xFF,0x03,
		0x00,0x8C,0xD7,0xF0,0xFE,0x2A,0x43,0x56,0x7E,0xAA,0xDF,0x26,0x9A,0x05,0x62,0xAA,0xFC,0x00,0x54,0x95,0xFE,0x03,			
	};
#elif(GM_8)
	unsigned int _8_value[] =
	{
		//	8 inch
	0x00,0x00,0x00,0xE1,0xF0,0x40,0xCF,0x05,0x10,0xF7,0xF5,0x20,0x20,0x20,0x10,0x10,0x10,0x50,0x20,0x50,0x20,0x00,0x00,
		0x00,0xC8,0x36,0x5C,0x70,0x92,0xAD,0xC3,0xEF,0x1E,0x53,0x99,0x03,0x5A,0x9C,0xCB,0xFC,0x50,0x55,0xA9,0xFF,0x03,
		0x00,0x97,0xEF,0x0E,0x1C,0x3B,0x53,0x69,0x91,0xC0,0xF7,0x41,0xB6,0x1C,0x70,0xB3,0xFC,0x40,0x55,0x95,0xFE,0x03,
		0x00,0xC8,0x36,0x5C,0x70,0x92,0xAD,0xC3,0xEF,0x1E,0x53,0x99,0x03,0x5A,0x9C,0xCB,0xFC,0x50,0x55,0xA9,0xFF,0x03,
		0x00,0x97,0xEF,0x0E,0x1C,0x3B,0x53,0x69,0x91,0xC0,0xF7,0x41,0xB6,0x1C,0x70,0xB3,0xFC,0x40,0x55,0x95,0xFE,0x03,
		0x00,0xC8,0x36,0x5C,0x70,0x92,0xAD,0xC3,0xEF,0x1E,0x53,0x99,0x03,0x5A,0x9C,0xCB,0xFC,0x50,0x55,0xA9,0xFF,0x03,
		0x00,0x97,0xEF,0x0E,0x1C,0x3B,0x53,0x69,0x91,0xC0,0xF7,0x41,0xB6,0x1C,0x70,0xB3,0xFC,0x40,0x55,0x95,0xFE,0x03			
	};
#elif(BMW_10_25)	
	unsigned int _10_25_value[] =
	{
		//	8 inch
				
	0x00,0x00,0x00,0xE1,0xF0,0x40,0xCF,0x05,0x10,0xFC,0xF0,0x20,0x20,0x20,0x10,0x10,0x10,0x50,0x20,0x50,0x20,0x00,0x00, 
		0x00,0xEB,0x28,0x40,0x4D,0x70,0x8B,0xA1,0xCD,0xFD,0x36,0x7F,0xEE,0x42,0x83,0xB6,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xF4,0x2E,0x44,0x4F,0x6E,0x86,0x99,0xBD,0xE6,0x16,0x55,0xBA,0x0D,0x56,0x95,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xEB,0x28,0x40,0x4D,0x70,0x8B,0xA1,0xCD,0xFD,0x36,0x7F,0xEE,0x42,0x83,0xB6,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xF4,0x2E,0x44,0x4F,0x6E,0x86,0x99,0xBD,0xE6,0x16,0x55,0xBA,0x0D,0x56,0x95,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xEB,0x28,0x40,0x4D,0x70,0x8B,0xA1,0xCD,0xFD,0x36,0x7F,0xEE,0x42,0x83,0xB6,0xFC,0x50,0x55,0xA5,0xFE,0x03,
		0x00,0xF4,0x2E,0x44,0x4F,0x6E,0x86,0x99,0xBD,0xE6,0x16,0x55,0xBA,0x0D,0x56,0x95,0xFC,0x50,0x55,0xA5,0xFE,0x03			
	};
#endif

	unsigned int Input[22*7];
	unsigned int Output[22*7];
	unsigned int length;
	unsigned int cmd;
	unsigned int addr;
	unsigned int* DataIn;
	unsigned int* DataOut;
	unsigned int* Length;
	unsigned int VCOM;
//*************************************************************************************
	#if 1
	uint16_t SPI_CLK	=	SCL;			//	for SPI interface
	uint16_t SPI_CS		=	CSB;
	uint16_t SPI_MOSI	=	SDAI;
	uint16_t SPI_MISO	=	SDAO;		
	#endif // variable block

//*************************************************************************************
// Limit value
//*************************************************************************************
#define I_VBL_MAX					1
#define I_VBL_MIN					0
#define I_VCC_MAX					1
#define I_VCC_MIN					0
#define I_VDDP_MAX					1
#define I_VDDP_MIN					0
#define I_VDDN_MAX					0
#define I_VDDN_MIN					-1
#define I_VGH_MAX					1
#define I_VGH_MIN					0
#define I_VGL_MAX					0
#define I_VGL_MIN					-1
	
#include "SPI.h"
#include "Display.h"
#include "Power.h"
#include "Communication.h"
#include "Misc.h"

#endif /*PROJECT_SETTING_H_*/
