#ifndef TOOL_H
#define TOOL_H

#define DEBUG 1
#define SAMPLE 100				//	the number sample to measuring Vp-p
extern uint8_t flicker_input;
unsigned int VCOM_4_2	= 170;	
unsigned int VCOM_8		= 153;	
unsigned int VCOM_10_25 = 169;
unsigned int fail_time = 3;
unsigned int search_time =0;
unsigned int Is_fail = 0;

float test_value;	
uint8_t message[32];
uint8_t temp_string[64];
uint8_t temp_string2[64];
// flicker measure 50 times.
unsigned int flicker_longging1[50];
float flicker_longging2[50];

void int2str(int i, char *s)
{
  sprintf(s,"%d",i);
}

uint8_t test_function(uint8_t *Test_Name,uint8_t *Test_slot,float input_value, float Min_Value, float Max_Value)
{		
	strcpy(message,Test_Name);
	strcpy((message+strlen(message)),Test_slot);
	
	if(!strcmp(Test_slot,"(VBL_SEN)"))	
	{
		test_value = ((In_Adc((uint8_t)input_value,10)/50)/0.12);			
		strcpy((message+strlen(message)),"%5.3fA");
		return Test_Float(message,test_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(VCC_SEN)"))	
	{
		test_value = ((In_Adc((uint8_t)input_value,10)/50)/0.47);				
		strcpy((message+strlen(message)),"%5.3fA");
		return Test_Float(message,test_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(VDDP_SEN)"))
	{							
		test_value = In_Adc((uint8_t)input_value,10);
		strcpy((message+strlen(message)),"%5.3fA");
		return Test_Float(message,test_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(VDDN_SEN)"))	
	{				
		test_value = In_Adc((uint8_t)input_value,10);
		strcpy((message+strlen(message)),"%5.3fA");
		return Test_Float(message,test_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(VGH_SEN)"))	
	{						
		test_value = In_Adc((uint8_t)input_value,10);
		strcpy((message+strlen(message)),"%5.3fA");
		return Test_Float(message,test_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(VGL_SEN)"))	
	{					
		test_value = In_Adc((uint8_t)input_value,10);
		strcpy((message+strlen(message)),"%5.3fA");
		return Test_Float(message,test_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(VCOM)"))
	{		
		strcpy((message+strlen(message)),"%d");
		return Test_Integer(message,input_value,Min_Value,Max_Value);
	}
	else if(!strcmp(Test_slot,"(flicker)"))
	{		
		strcpy((message+strlen(message))," %5.3fV");
		return Test_Float(message,input_value,Min_Value,Max_Value);		
	}
	else
	{		
		strcpy((message+strlen(message)),"%d");
		return Test_Integer(message,input_value,Min_Value,Max_Value);
	}
}

float Measure_Vpp(unsigned int sample, uint8_t channel)
{
	unsigned int i;
	float sample_value[SAMPLE];
	float VMax = 0.0;
	float VMin = 0.0;	
	for(i = 0; i < sample; i++)
	{
		sample_value[i] = In_Adc(channel,1);		
	}
	VMax = sample_value[0];
	VMin = sample_value[0];
	for(i = 0; i < sample; i++)
	{		
		if(sample_value[i] > VMax)
		VMax = sample_value[i];
		else if(sample_value[i] < VMin)
		VMin = sample_value[i];
	}		
	return (VMax - VMin);
}

void Set_VCOM(unsigned int VCOM)
{	
	cmd = 0x00;
	addr = 0x01;
	Input[0] = VCOM;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];    	
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);	
}

unsigned int find_flicker(unsigned int VCOM_Min, unsigned int VCOM_Max, unsigned int VCOM)
{
	float flicker_Current = 0;
	float flicker_last = 0;
	
	unsigned int VCOM_Current;
	unsigned int VCOM_last;
	unsigned int Is_find = 0;
	VCOM_last = VCOM;//no use

	Set_VCOM(VCOM_Min);
	Wait(32);//wait 2 frame
	flicker_last = Measure_Vpp(SAMPLE,flicker_input);
	VCOM_last = VCOM_Min;
	for(VCOM_Current=VCOM_Min+1;VCOM_Current<=VCOM_Max;VCOM_Current++)
	{
		Set_VCOM(VCOM_Current);		
		Wait(32);//wait 2 frame
		flicker_Current = Measure_Vpp(SAMPLE,flicker_input);		
		
		if(flicker_last >= flicker_Current)
		{	
			if(((VCOM_Current - VCOM_last) > 1)&&(Is_find==1))			
			{
				if(Is_fail==0)
				Is_fail = 2;
			}
			
			flicker_last = flicker_Current;
			VCOM_last = VCOM_Current;
			Is_find = 0;
		}
		else
		{
			if(Is_find == 0)
			{
				Is_find = 1;				
			}			
		}
		
		if(DEBUG)
		{			
			flicker_longging1[search_time] = VCOM_Current;			
			flicker_longging2[search_time++] = flicker_Current;	
		}		
	}

	return VCOM_last;
}

/*
unsigned int find_flicker(unsigned int VCOM_Min, unsigned int VCOM_Max, unsigned int VCOM_Current)
{
	float flicker_right = 0;
	float flicker_left = 0;
	float flicker_Current = 0;	

	if(VCOM_Min == VCOM_Max)
		return VCOM_Current;
	
	if(VCOM_Current == 0x00)
		VCOM_Current = 0x01;
	if(VCOM_Min == 0x00)
		VCOM_Min = 0x01;
	if(VCOM_Max == 0x00)
		VCOM_Max = 0x01;

	if((VCOM_Current < VCOM_Min) || (VCOM_Current > VCOM_Max))
	{
		Clear_Screen();
		Display_Message("The vlaue VCOM out of range.");
		Wait_Halt(100);
		while(!Start_Pressed());		
		return 0;
	}	
	Set_VCOM(VCOM_Current);
	Wait(32);//wait 2 frame
	flicker_Current = Measure_Vpp(SAMPLE,flicker_input);
	
	Set_VCOM((unsigned int)((VCOM_Max + VCOM_Current)/2));
	Wait(32);
	flicker_right = Measure_Vpp(SAMPLE,flicker_input);		
	
	Set_VCOM((unsigned int)((VCOM_Min + VCOM_Current)/2));
	Wait(32);
	flicker_left = Measure_Vpp(SAMPLE,flicker_input);	
	
	if(DEBUG)
	{
		flicker_longging1[search_time] =VCOM_Current;
		flicker_longging2[search_time++] =flicker_Current;
		flicker_longging1[search_time] =(unsigned int)((VCOM_Max + VCOM_Current)/2);
		flicker_longging2[search_time++] =flicker_right;
		flicker_longging1[search_time] =(unsigned int)((VCOM_Min + VCOM_Current)/2);
		flicker_longging2[search_time++] =flicker_left;	
	}
	Set_VCOM(VCOM_Current);
	if(flicker_right < flicker_left)
	// go to right
		return find_flicker(VCOM_Current,VCOM_Max, (unsigned int)((VCOM_Max + VCOM_Current)/2));
	else
	// go to left
		return find_flicker(VCOM_Min, VCOM_Current, (unsigned int)((VCOM_Min + VCOM_Current)/2));
}
*/

uint8_t otp(void)
{	
	
	unsigned int temp = 0;
	unsigned int pad = 0;
	unsigned int limit = 20;
	unsigned int i =0;
	//SetDigitalControl(BIST);
	//Display_Bitmap( pattern, flicker_dot);
	
#if(GM_4_2)
	VCOM = VCOM_4_2;
#elif(GM_8)
	VCOM = VCOM_8;
#elif(BMW_10_25)
	VCOM = VCOM_10_25;
#else
	RedLed(1);
#endif
	cmd = 0x04;
	addr = 0x01;
	Input[0] = 0x00;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
				
	Display_Integer("\nVcom is %d\n",Output[0]);	
	test_function("Auto flicker"," Panel Vcom before otp",Output[0],0,255);
	
	Is_fail = 0;
	if(Output[0] == 0)
	{
		GreenLed(1);		
	}	
	else
	{	
		Wait_Halt(100);		
		Is_fail = 1;
	}
	Clear_Screen();  
	if(AUTO_FLICKER)
	{		
		cmd = 0x00;
		addr = 0x05;
		Input[0] = 0x08;	
		length = 1;
		Length = &length;
		DataIn = &Input[0];
		DataOut = &Output[0];
		
		SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length); // vcom control by spi
		
		search_time = 0;
		
		if(VCOM <= 25)
			temp = find_flicker(0,50,VCOM);
		else if(VCOM >= 230)
			temp = find_flicker(205,255,VCOM);
		else
			temp = find_flicker(VCOM-25,VCOM+25,VCOM);					
		
		if(TESTMODE)
		{			
			test_function("Auto flicker"," Sensor Vcom",temp,0,255);
			test_function("Auto flicker"," Default Vcom",VCOM,0,255);			
		}
		if((temp - VCOM)<limit)		
			VCOM = temp;		
		else if((VCOM - temp)<limit)
			VCOM = temp;
		else
		{	
			if(Is_fail==0)
			Is_fail = 3;				
		}				
	}	
	
	cmd = 0x00;
	addr = 0x00;
	Input[0] = 0x07;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	cmd = 0x00;
	addr = 0x02;
	Input[0] = 0x66;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	Clear_Screen(); 
	Display_Message("OTP Process...");
	Out_Dac(VDD_OTP,VDD_otp);
	Wait_Halt(100);

	do
	{
	cmd = 0x00;
	addr = 0x03;
	Input[0] = VCOM;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);

	cmd = 0x04;
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	if(Output[0] == VCOM)
	{
		break;
	}
	else if(fail_time == 0)
	{
		Display_Integer("Votp_DIN is %d",Output[0]);
		Wait_Halt(100);
		if(Is_fail==0)
		Is_fail = 4;
		break;
	}						 	
	fail_time = fail_time - 1;	
	}while(1);
	
	if(Is_fail > 0)
	{		
		goto RST;
	}
	
	cmd = 0x00;
	addr = 0x05;
	Input[0] = 0x08 + pad;	//pad
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	cmd = 0x00;
	addr = 0x04;
	Input[0] = 0x02;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	cmd = 0x00;
	addr = 0x04;
	Input[0] = 0x03;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	cmd = 0x00;
	addr = 0x04;
	Input[0] = 0x07;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	Wait(1000);

	cmd = 0x00;
	addr = 0x04;
	Input[0] = 0x03;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	cmd = 0x00;
	addr = 0x04;
	Input[0] = 0x02;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);	
	
	cmd = 0x00;
	addr = 0x04;
	Input[0] = 0x00;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	Wait(100);	

	cmd = 0x00;
	addr = 0x02;
	Input[0] = 0x00;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("OTP Process...\n");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	Out_Dac(VDD_OTP,0);
	Wait(100);
	
	Clear_Screen();
RST:
	Init_Power();	
	Init_Protocol(pattern);
	Display_Bitmap( pattern, flicker_dot_186);

	Wait_Halt(100);

	cmd = 0x04;
	addr = 0x01;
	Input[0] = 0x00;	
	length = 1;
	Length = &length;
	DataIn = &Input[0];
	DataOut = &Output[0];
	Clear_Screen();   
    Display_Message("\nOTP finish: check the vcom value.\n");
	SPI_RW_Burst(cmd,addr,&DataIn,DataOut,Length);
	
	Display_Integer("Vcom is %d",Output[0]);	
	test_function("Auto flicker"," Panel Vcom after otp",Output[0],0,255);
	
	if(Output[0] == VCOM)
	{				
	}	
	else if(Is_fail == 0)
	{			
		Is_fail = 5;
	}
	test_function("Error massage:"," error code",Is_fail,0,255);
	// data logging to debug
	if(DEBUG)
	{
		for(i = 0;i<50;i++)
		{				
			int2str(i,temp_string);
			strcpy(temp_string2,"VCOM ");
			strcpy((temp_string2+strlen(temp_string2)),temp_string);
			strcpy((temp_string2+strlen(temp_string2))," at ");
			int2str(flicker_longging1[i],temp_string);
			strcpy((temp_string2+strlen(temp_string2)),temp_string);
			strcpy((temp_string2+strlen(temp_string2)),"(Vp-p)");				
			test_function(temp_string2,"(flicker)",flicker_longging2[i],0,Vop);				
		}		
	}
	
	
	if(Is_fail == 1)
	{
		Display_Message("\nVCOM is not empty...\n");
		Wait_Halt(100);		
	}
	else if(Is_fail == 2)
	{
		Display_Message("\nThe sensor is not ready...\n");
		Wait_Halt(100);
		RedLed(1);		
	}
	else if(Is_fail == 3)
	{
		Display_Message("\nVCOM is out of limit.\n");
		Wait_Halt(100);
		RedLed(1);		
	}
	else if(Is_fail == 4)
	{
		Display_Message("\nThe OTP is fail!!, SPI communication error.\n");
		Wait_Halt(100);
		RedLed(1);		
	}
	else if(Is_fail == 5)
	{
		Display_Message("\nThe OTP is fail!!\n");
		Wait_Halt(100);
		RedLed(1);		
	}
	else
	{
		GreenLed(1);
		Display_Message("\nThe OTP is successful!!\n");
	}	
	
	return 1;
}
#elif
#endif
